//
//  GameView.swift
//  ArkitDoushiQi
//
//  Created by Enzo JOLYS, Louis DUFOUR on 27/05/2024.
//

import SwiftUI
import SpriteKit
import DouShouQiModel

struct GameView: View {
    var player1Name: String = "toto"
    var player1Image: UIImage
    var player2Name: String = "toto"
    var player2Image: UIImage
    
    var vm:VMGame = VMGame()

    var body: some View {
        ZStack {
            Text(msg)
            SpriteView(scene: gameScene)
                .edgesIgnoringSafeArea(.all)
                .task { vm.start() }

            VStack {
                HStack {
                    VStack {
                        Image("profil")
                            .resizable()
                            .aspectRatio(contentMode: .fill)
                            .frame(width: 125, height: 125)
                            .clipShape(Circle())
                            .overlay(Circle().stroke(Color.red, lineWidth: 2))

                        Text(player1Name)
                            .font(.headline)
                            .foregroundColor(.white)
                    }
                    Spacer()
                    VStack {
                        Image("profil")
                            .resizable()
                            .aspectRatio(contentMode: .fill)
                            .frame(width: 125, height: 125)
                            .clipShape(Circle())
                            .overlay(Circle().stroke(Color.blue, lineWidth: 2))

                        Text(player2Name)
                            .font(.headline)
                            .foregroundColor(.white)
                    }
                }
                .padding()
                Spacer()
                Text(msg)
                    .font(.title)
                    .foregroundColor(.white)
                    .padding()
            }
        }
    }
    
    init(playerName1:String,image1:UIImage,player2Name:String,image2:UIImage){
        
        //self.player1Name = playerName1
        self.player1Image = image1
        //self.player2Name = player2Name
        self.player2Image = image2
    }
}

